/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.x86.PE;
import ru.ispras.microtesk.model.x86.TempVars;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class DIV_R16 extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "DIV_R16",
          DIV_R16.class,
          null
          );
      addArgument("op1", GPR16.INFO);
      addShortcut(new Info_x86(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final GPR16 op1 = (GPR16) getArgument("op1", args);

      return new DIV_R16(op1);
    }
  }
  private static final class Info_x86 extends IsaPrimitiveInfoAnd {
    Info_x86() {
      super(
          IsaPrimitiveKind.OP,
          "DIV_R16",
          x86.class,
          null
          );
      addArgument("op1", GPR16.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final GPR16 op1 = (GPR16) getArgument("op1", args);

      return new x86(
        new DIV_R16(
          op1
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final GPR16 op1;

  public DIV_R16(final GPR16 op1) {
    assert GPR16.INFO.isSupported(op1);

    this.op1 = op1;

    addArgument("op1", op1);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("DIV %s", op1.syntax(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("1111011111000%s", op1.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.tmpdw_op1.access().bitField(15, 0).store(pe__.AX.access().load());
    vars__.tmpdw_op1.access().bitField(31, 16).store(pe__.DX.access().load());
    vars__.tmpdw_op2.access().store(vars__.tmpdw_op1.access().load().divide(Data.zeroExtend(DWORD, op1.access(pe__, vars__).load())));
    vars__.instr_size.access().store(vars__.instr_size.access().load().add(Data.valueOf(SIZE, 0x2)));
    if ((vars__.tmpdw_op1.access().load().compareTo(Data.valueOf(DWORD, 0xffff)) <= 0)) {
      pe__.AX.access().store(Data.coerce(WORD, vars__.tmpdw_op2.access().load()));
      pe__.DX.access().store(Data.coerce(WORD, vars__.tmpdw_op1.access().load().mod(Data.zeroExtend(DWORD, op1.access(pe__, vars__).load()))));
    }
  }
}